/*Joo Won Park
www.joowonpark.net
Sony DualShock 4 Controller Element Assignments for SuperCollider
Updated: September 6, 2018*/

//Preparation:
HID.findAvailable; //run this line first to intialize once the connection between the computer and the controller is established
HID.postAvailable; //you should see the controller as 'Wireless Controller"
~myhid = HID.open( 1356, 2508 ); // run this line to assign Dualshock to the example codes below
//try  (1356,1476) if the controller is not recognized

//Run the following codes to test test the Elements. numbers in [ ] corresponds to the Element number
//Digital Buttons

HIDFunc.element({ |...args| args[1].postln; }, [0]);//square
HIDFunc.element({ |...args| args[1].postln; }, [1]);//X
HIDFunc.element({ |...args| args[1].postln; }, [2]);//O
HIDFunc.element({ |...args| args[1].postln; }, [3]);//tri
HIDFunc.element({ |...args| args[1].postln; }, [4]); //L1
HIDFunc.element({ |...args| args[1].postln; }, [5]); //R2
HIDFunc.element({ |...args| args[1].postln; }, [6]); //L2
HIDFunc.element({ |...args| args[1].postln; }, [7]); //R2
HIDFunc.element({ |...args| args[1].postln; }, [8]); //Share
HIDFunc.element({ |...args| args[1].postln; }, [9]); //Options
HIDFunc.element({ |...args| args[1].postln; }, [10]); //L3
HIDFunc.element({ |...args| args[1].postln; }, [11]); //R3
HIDFunc.element({ |...args| args[1].postln; }, [12]); //PS button
HIDFunc.element({ |...args| args[1].postln; }, [13]); //Trackpad Button

//Analog Control
HIDFunc.element({ |...args| args[1].postln; }, [18]);//direction buttons
//range 0-7 (physical range = 0-315?)
//(0up-2right-4down-6left, 8 rel)
//(1-3-5-7 in betweens)

HIDFunc.element({ |...args| args[1].postln; }, [14]); //joystick(L3) X. 0:left, 255:right, center is unstable sometimes
HIDFunc.element({ |...args| args[1].postln; }, [15]); //joystick(L3) Y
HIDFunc.element({ |...args| args[1].postln; }, [16]); //joystick(R3) X
HIDFunc.element({ |...args| args[1].postln; }, [17]); //joystick(R3) Y

HIDFunc.element({ |...args| args[1].postln; }, [20]); //L2, 0-255 (Element #19 in Bluetooth)
HIDFunc.element({ |...args| args[1].postln; }, [21]); //R2, 0-255 (Element #20 in Bluetooth)


//Trackpad
//does not work in Bluetooth/wireless mode

HIDFunc.element({ |...args| args[1].postln; }, 48);//touch timer
HIDFunc.element({ |...args| args[1].postln; }, 49);//one finger on off counter
//off = on+128
//on range: 0-127 (off range 128-255)
HIDFunc.element({ |...args| args[1].postln; }, 50); //x position tracker
HIDFunc.element({ |...args| args[1].postln; }, 51); //X directions
HIDFunc.element({ |...args| args[1].postln; }, 52);//Y position (0~58)
HIDFunc.element({ |...args| args[1].postln; }, 53);//two finger on off
HIDFunc.element({ |...args| args[1].postln; }, 54);//two finger x position
HIDFunc.element({ |...args| args[1].postln; }, 55);//two finger y position (increase: down, decrease: up)
HIDFunc.element({ |...args| args[1].postln; }, 56);//two finger y position



//Sixaxis
//does not work in Bluetooth/wireless mode
//Roll
HIDFunc.element({ |...args| args[1].postln; }, [32]);//roll acc
HIDFunc.element({ |...args| args[1].postln; }, [34]);//roll gyro
//Pitch
HIDFunc.element({ |...args| args[1].postln; }, [28]);//pitch acc
HIDFunc.element({ |...args| args[1].postln; }, [36]);//pitch gyro, 0 at ceiling
HIDFunc.element({ |...args| args[1].postln; }, [38]);//pitch gyro, 0 at front
//Yaw
HIDFunc.element({ |...args| args[1].postln; }, [30]);//yaw acc

//Timer
HIDFunc.element({ |...args| args[1].postln; }, [19]);//timer. 0-63
HIDFunc.element({ |...args| args[1].postln; }, [25]);//timer 0-256

//Unidentified controllers: running the code below has a risk of crashing the program
/
HIDFunc.element({ |...args| args[1].postln; }, [22]); //large range
HIDFunc.element({ |...args| args[1].postln; }, [23]); //large range
HIDFunc.element({ |...args| args[1].postln; }, [24]);//

HIDFunc.element({ |...args| args[1].round(20).postln; }, [33]);//too much

//unstable and largely varying streams of data.
HIDFunc.element({ |...args| args[1].postln; }, [27]);//danger?
HIDFunc.element({ |...args| args[1].postln; }, [29]);//too many data danger : accel detecting gravity?
HIDFunc.element({ |...args| args[1].postln; }, [31]);//? too many data (danger)
HIDFunc.element({ |...args| args[1].postln; }, [33]);//? too many data (danger)
HIDFunc.element({ |...args| args[1].postln; }, [35]);//? danger
HIDFunc.element({ |...args| args[1].postln; }, [37]);//danger

//nothing
HIDFunc.element({ |...args| args[1].postln; }, [26]);//nothing
HIDFunc.element({ |...args| args[1].postln; }, (39..47));// blank
HIDFunc.element({ |...args| args[1].postln; }, [59]);//nothing
HIDFunc.element({ |...args| args[1].postln; }, (60..1000));// blank